import { Component, OnInit,ViewChild,ElementRef,EventEmitter, Output } from '@angular/core';
import { HttpClient, HttpParams,HttpHeaders } from "@angular/common/http";
import {NgbModal} from "@ng-bootstrap/ng-bootstrap"
import { ImageCroppedEvent,LoadedImage } from 'ngx-image-cropper';
import {ImageService } from '../../services/image.service';

@Component({
  selector: 'fm-edit-image-modal',
  templateUrl: './edit-image-modal.component.html',
  styleUrls: ['./edit-image-modal.component.scss']
})
export class EditImageModalComponent implements OnInit {

  @Output() changed = new EventEmitter();
  @ViewChild('upload_modal') modal:ElementRef;

  constructor(private modalService: NgbModal,public imageService:ImageService) { }

  isImageLoaded:boolean = false;
  aspectRatio:number = 4/3;
  imageChangedEvent: any = '';
  croppedImage: string = '';
  endpointUrl:string = null;
  imageUrl:string = null;

  ngOnInit(): void {
  }

  open(endpoint:string,aspectRatio:number) {
    this.endpointUrl = endpoint;
    this.imageUrl = endpoint;
    this.aspectRatio= aspectRatio;
    this.modalService.open(this.modal,{ size: 'lg' });
  }

  fileChangeEvent(event: any): void {
      this.imageChangedEvent = event;
  }
  imageCropped(event: ImageCroppedEvent) {
      this.croppedImage = event.base64;
  }
  imageLoaded(image: LoadedImage) {
    this.isImageLoaded=true;
  }
  cropperReady() {
      // cropper ready
  }
  loadImageFailed() {
      // show message
  }

  save() {
    if(this.croppedImage) {
      
      var body = this.croppedImage.substr(23);
      this.imageService.putImage(this.endpointUrl,this.imageService.b64toBlob(body,"image/jpeg")).subscribe(() => {
        this.changed.emit({});
      });    
      this,this.modalService.dismissAll("Save");
    }
  }
}
